<?php
/**
 * @file
 * Contains Licensing information for miniOrange OAuth Client Login Module.
 */

/**
 * Showing Licensing form info.
 */
namespace Drupal\miniorange_oauth_client\Form;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Form\FormBase;
use Drupal\miniorange_oauth_client\MiniorangeOAuthClientSupport;
use Drupal\miniorange_oauth_client\Utilities;
use Drupal\miniorange_oauth_client\mo_saml_visualTour;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Drupal\miniorange_oauth_client\MiniorangeOAuthClientConstants;

class MiniorangeLicensing extends FormBase {

    public function getFormId() {
        return 'miniorange_oauth_client_licensing';
    }

    public function buildForm(array $form, FormStateInterface $form_state)
    {
        global $base_url;

        $moTour = mo_saml_visualTour::genArray();
        $form['tourArray'] = array(
            '#type' => 'hidden',
            '#value' => $moTour,
        );

        $form['markup_library'] = array(
            '#attached' => array(
                'library' => array(
                    "miniorange_oauth_client/miniorange_oauth_client.admin",
                    "miniorange_oauth_client/miniorange_oauth_client.style_settings",
                    "miniorange_oauth_client/miniorange_oauth_client.module",
                    "miniorange_oauth_client/miniorange_oauth_client.Vtour",
                    "miniorange_oauth_client/miniorange_oauth_client.main",
                    "miniorange_oauth_client/miniorange_oauth_client.slide_support_button",
                )
            ),
        );

        $module_path = drupal_get_path('module', 'miniorange_oauth_client');


        if(!Utilities::isCustomerRegistered())
        {
            $username = \Drupal::config('miniorange_oauth_client.settings')->get('miniorange_oauth_client_customer_admin_email');
            $URL_Redirect_std = "https://login.xecurify.com/moas/login?username=".$username."&redirectUrl=https://login.xecurify.com/moas/initializepayment&requestOrigin=drupal8_oauth_client_standard_plan";
            $URL_Redirect_pre = "https://login.xecurify.com/moas/login?username=".$username."&redirectUrl=https://login.xecurify.com/moas/initializepayment&requestOrigin=drupal8_oauth_client_premium_plan";
            $URL_Redirect_ent = "https://login.xecurify.com/moas/login?username=".$username."&redirectUrl=https://login.xecurify.com/moas/initializepayment&requestOrigin=drupal8_oauth_client_enterprise_plan";
            $targetBlank = 'target="_blank"';
        } else {
            \Drupal::configFactory()->getEditable('miniorange_oauth_client.settings')->set('miniorange_oauth_client_redi_upgrade', '1')->save();
            $URL_Redirect_std = $base_url.'/admin/config/people/miniorange_oauth_client/customer_setup';
            $URL_Redirect_pre = $base_url.'/admin/config/people/miniorange_oauth_client/customer_setup';
            $URL_Redirect_ent = $base_url.'/admin/config/people/miniorange_oauth_client/customer_setup';
            $targetBlank = '';
        }

        $form['header_top_style_2'] = array(
            '#markup' => '<div class="mo_oauth_table_layout_1"><div class="mo_oauth_table_layout">'
        );

        $form['markup_1'] = array(
            '#markup' =>'<br><h3>UPGRADE PLANS  <a id="Restart_moTour" class="mo_oauth_btn mo_oauth_btn_restart_tour mo_oauth_btn-primary-color mo_oauth_btn-large">Take a Tour</a></h3><hr>'
        );

        $form['markup_free'] = array(
            '#markup' => t('<html lang="en">
        <head>
            <meta charset="utf-8">
            <meta name="viewport" content="width=device-width, initial-scale=1">
            <!-- Main Style -->
        </head>
        <body>

        <!--Heading-->
    <br><h2 id="pricing-header">Drupal OAuth/OIDC Client Configurations</h2
<!--Heading End -->

<!--Navbar-->
<div class="topnav sticky" id="topnav" >
  <a href="#plans">Plans</a>
  <a href="#what_is_instance">Instance</a>
  <a href="#feature_comparison">Feature Comparison</a>
  <a href="#steps_upgrade_premium">Upgrade Steps</a>
  <a href="#faq">FAQs</a>
  <a href="#video">Premium Videos</a>
  <a href="#payment_method">Payment Methods</a>
</div>

<!--End Navbar-->

<!-- Contact Us -->
<div id="contact">
<br>
<h2>Choose Your Licensing Plan</h2>
<h4>Need any assistance in choosing a plan?
<a href="mailto:drupalsupport@xecurify.com">Contact Us</a></h4>
  
</div>
<!-- End of Contact US-->
<!-- Plans Cards -->
<div class="container mo-container plan_cards_main " id="plans">
    <div class="row">
        <div class="col-md-3 plan_cards_inner_divs">
        <div class="card">
          <div class="mo-price-hover">
            <h5 class="pricing-card-head mt-0 mb-0">Standard Plan</h5>
            <div class="card-body">
            <p class="card-text sup_price" id="standard_price"><sup>$</sup>249</p>
            <p id="standard_discount"></p>
                <span class="instance_dropdown">
                <label for="instances_standard">Instances:</label>
                <select id="instances_standard" name="instances" onchange="Instance_Pricing(this.value,instances_premium,instances_allinclusive)">
                    <option value="1">1</option>
                    <option value="2">2</option>
                    <option value="3">3</option>
                    <option value="4">4</option>
                    <option value="5">5</option>
                    <option value="6">6</option>
                    <option value="7">7</option>
                    <option value="8">8</option>
                    <option value="9">9</option>
                    <option value="10">10</option>
                    <option value="15">15</option>
                    <option value="20">20</option>
                    <option value="30">30</option>
                    <option value="40">40</option>
                    <option value="50">50</option>
                </select>
                </span>
            </div>
          </div>  
            <a href="' . MiniorangeOAuthClientConstants::BASE_URL . '/moas/login?redirectUrl=' . MiniorangeOAuthClientConstants::BASE_URL . '/moas/initializepayment&requestOrigin=drupal8_oauth_client_standard_plan" target="_blank"><p class="card-footer mo-card-footer mb-0 mt-0 pt-3 pb-3">UPGRADE NOW</p></a>
        </div>
        </div>
        <div class="col-md-3 plan_cards_inner_divs">
        <div class="card">
          <div class="mo-price-hover">
            <h5 class="pricing-card-head mt-0 mb-0">Premium Plan</h5>
            <div class="card-body">
            <p class="card-text sup_price" id="premium_price"><sup>$</sup>399</p>
            <p id="premium_discount"></p>
                <span class="instance_dropdown">
                <label for="instances_premium">Instances:</label>&nbsp;&nbsp;
                <select id="instances_premium" name="instances" onchange="Instance_Pricing(this.value,instances_standard,instances_allinclusive)">
                    <option value="1">1</option>
                    <option value="2">2</option>
                    <option value="3">3</option>
                    <option value="4">4</option>
                    <option value="5">5</option>
                    <option value="6">6</option>
                    <option value="7">7</option>
                    <option value="8">8</option>
                    <option value="9">9</option>
                    <option value="10">10</option>
                    <option value="15">15</option>
                    <option value="20">20</option>
                    <option value="30">30</option>
                    <option value="40">40</option>
                    <option value="50">50</option>
                </select>
                </span>
            </div>
          </div>
            <a href="' . MiniorangeOAuthClientConstants::BASE_URL . '/moas/login?redirectUrl='. MiniorangeOAuthClientConstants::BASE_URL . '/moas/initializepayment&requestOrigin=drupal8_oauth_client_premium_plan" target="_blank"><p class="card-footer mo-card-footer mb-0 mt-0 pt-3 pb-3">UPGRADE NOW</p></a>
        </div>
        </div>

    <div class="col-md-3  plan_cards_inner_divs">
        <div class="card">
          <div class="mo-price-hover">
            <h5 class="pricing-card-head mt-0 mb-0">Enterprise Plan</h5>
            <div class="card-body">
            <p  class="card-text sup_price" id="AllInclusive_price" > <sup>$</sup>449</p>
             <p id="AllInclusive_discount"></p>
                <span class="instance_dropdown">
                <label for="instances_allinclusive">Instances:</label>&nbsp;&nbsp;
                <select id="instances_allinclusive" onchange="Instance_Pricing(this.value,instances_standard,instances_premium)">
                    <option value="1" >1</option>
                    <option value="2" >2</option>
                    <option value="3" >3</option>
                    <option value="4" >4</option>
                    <option value="5" >5</option>
                    <option value="6" >6</option>
                    <option value="7" >7</option>
                    <option value="8" >8</option>
                    <option value="9" >9</option>
                    <option value="10">10</option>
                    <option value="15" >15</option>
                    <option value="20" >20</option>
                    <option value="30" >30</option>
                    <option value="40" >40</option>
                    <option value="50" >50</option>
                </select>
            </span>
            </div>
            </div>
            <a href="' . MiniorangeOAuthClientConstants::BASE_URL . '/moas/login?redirectUrl=' . MiniorangeOAuthClientConstants::BASE_URL . '/moas/initializepayment&requestOrigin=drupal8_oauth_client_enterprise_plan" target="_blank"><p class="card-footer mo-card-footer mb-0 mt-0 pt-3 pb-3">UPGRADE NOW</p></a>
        </div>
    </div><div id="what_is_instance"></div>
</div>
</div>
<!-- Plan Cards End -->

<!-- What is Instance -->
<div class="container mo-container instance" >
 <h3>What is a Instance ?</h3> <div id="feature_comparison"></div>
 <p>A Drupal instance refers to a single installation of a Drupal site. It refers to each individual website where the module is active. In the case of multisite/subsite Drupal setup, each site with a separate database will be counted as a single instance. For eg. If you have the dev-staging-prod type of environment then you will require 3 licenses of the module (with additional discounts applicable on pre-production environments). Contact us at <a href="mailto:drupalsupport@xecurify.com">drupalsupport@xecurify.com</a> for bulk discounts.
 </p>

</div>

<!--End of Instance -->


<!--Features Comparison-->
 <div class="container mo-container" >
<a class="feature_comparison" id="feature_button" onClick="Show_Features()" >Click here for FEATURE COMPARISON</a>

<div id="mo_drupal_feature_table" style="display:none;">
<br><br>
<table>
      <tr id="feature_head">
        <th>Features List</th>
        <th>Free</th>
        <th>Standard</th>
        <th>Premium</th>
        <th>Enterprise</th>
      </tr>
      <tr>
        <td>OAuth Provider Support</td>
        <td>1</td>
        <td>1</td>
        <td>1</td>
        <td>Multiple*</td>
      </tr>
      <tr>
        <td>Autofill OAuth Server Configurations</td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
      </tr>
      <tr>
        <td>Basic Attribute Mapping(Email, Username)</td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
      </tr>
        <tr>
        <td>Export Configurations</td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
      </tr>
        <tr>
        <td>Auto Create Users</td>
        <td></td>
        <td>Unlimited</td>
        <td>Unlimited</td>
        <td>Unlimited</td>
      </tr>
          <tr>
        <td>Import Configurations</td>
        <td></td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
      </tr>
          <tr>
        <td>Advanced Attribute Mapping (Username, Email, First Name, Custom Attribute, etc.)</td>
        <td></td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
      </tr>
         <tr>
        <td>Custom Redirect URL after login and logout</td>
        <td></td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
      </tr>
      <tr>
        <td>Customize Login Button</td>
        <td></td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
      </tr>
      <tr>
        <td>Basic Role Mapping (Support for default role for new users)</td>
        <td></td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
      </tr>
      <tr>
        <td>Advanced Role Mapping </td>
        <td></td>
        <td></td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
      </tr>
      <tr>
        <td>Force Authentication / Protect complete site</td>
        <td></td>
        <td></td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
      </tr>
      <tr>
        <td>OpenId Connect Support (Login using OpenId Connect Server)</td>
        <td></td>
        <td></td>
        <td>&#x2714;</td>
        <td>&#x2714;</td>
      </tr>
      <tr>
        <td>Support for Headless integration</td>
        <td></td>
        <td></td>
        <td></td>
        <td>&#x2714;</td>
      </tr>
      <tr>
        <td>Domain specific registration</td>
        <td></td>
        <td></td>
        <td></td>
        <td>&#x2714;</td>
      </tr>
      <tr>
        <td>Support to set Access and ID tokens in session and cookies</td>
        <td></td>
        <td></td>
        <td></td>
        <td>&#x2714;</td>
      </tr>
      <tr>
        <td>Role based restriction for SSO login</td>
        <td></td>
        <td></td>
        <td></td>
        <td>&#x2714;</td>
      </tr>
      <tr>
        <td>Compatible with the Drupal Groups module</td>
        <td></td>
        <td></td>
        <td></td>
        <td>&#x2714;</td>
      </tr>
      <tr>
        <td>Compatible with the Drupal Profile module</td>
        <td></td>
        <td></td>
        <td></td>
        <td>&#x2714;</td>
      </tr>
      <tr>
        <td>Dynamic Callback URL</td>
        <td></td>
        <td></td>
        <td></td>
        <td>&#x2714;</td>
      </tr>
      <tr>
        <td>Page Restriction</td>
        <td></td>
        <td></td>
        <td></td>
        <td>&#x2714;</td>
      </tr>
      <tr>
        <td>Support for Group Info Endpoint </td>
        <td></td>
        <td></td>
        <td></td>
        <td>&#x2714;</td>
      </tr>
      <tr>
        <td>Support for PKCE flow</td>
        <td></td>
        <td></td>
        <td></td>
        <td>&#x2714;</td>
      </tr>
      <tr>
        <td>Login Reports / Analytics</td>
        <td></td>
        <td></td>
        <td></td>
        <td>&#x2714;</td>
      </tr>
</table>
</div>
</div>
<!-- Feature Comparison End -->
<!--How to upgrade to Licensed Version Module-->

<div class="container mo-container steps_upgrade_premium" id="steps_upgrade_premium">
<h3 style="text-align: center; margin-top:3%;">HOW TO UPGRADE TO LICENSED VERSION MODULE</h3><hr>
<div class="row">
  <div class="col-md-6">
  <div class="upgrade_step"><div class="upgrade_steps_wise">1</div> Click on Upgrade Now button for required licensed plan and you will be redirected to miniOrange login console.</div>
  <div class="upgrade_step"><div class="upgrade_steps_wise">2</div> Enter your username and password with which you have created an account with us. After that you will be redirected to payment page.</div>
  <div class="upgrade_step"><div class="upgrade_steps_wise">3</div> Enter your card details and proceed for payment. On successful payment completion, the Licensed version module(s) will be available to download.</div>
  <div class="upgrade_step"><div class="upgrade_steps_wise">4</div> Download the licensed module(s) from Module Releases and Downloads section.</div>
  </div>
  <div class="col-md-6">
  <div class="upgrade_step"><div class="upgrade_steps_wise">5</div> Uninstall and then delete the free version of the module from your Drupal site.</div>
  <div class="upgrade_step"><div class="upgrade_steps_wise">6</div> Now install the downloaded licensed version of the module.</div>
  <div class="upgrade_step"><div class="upgrade_steps_wise">7</div> Clear Drupal Cache from <a href="'.$base_url.'/admin/config/development/performance" target="_blank">here.</a></div>

  <div class="upgrade_step"><div class="upgrade_steps_wise">8</div> After enabling the licensed version of the module, login using the account you have registered with us.</div>
  </div>
</div>
</div><br><br>
<!-- End of Upgrade -->

<!--FAQ-->
<div class="container mo-container" id="faq">
  <h3 id="faq-heading" >Frequently Asked Questions</h3><br><hr><br>
  <div class= "row">
    <div class="col-md-6">
    
    <button type="button" class="collapsible">Are the Licenses Perpetual?</button>
    <div class="content">
      <p>The modules licenses are perpetual and includes 12 months of free maintenance (version updates). You can renew maintenance after 12 months at 50% of the current license cost.</p>
    </div>

    <button type="button" class="collapsible">Does miniOrange Offer Technical Support?</button>
    <div class="content">
      <p>Yes, we provide 24*7 support for all and any issues you might face while using the module, which includes technical support from our developers. You can get prioritized support based on the Support Plan you have opted.</p>
    </div>

    </div>
    <div class="col-md-6">
    
    <button type="button" class="collapsible">What is the Refund Policy?</button>
    <div class="content">
      <p>
      At miniOrange, we want to ensure you are 100% happy with your purchase. If the module that you purchased is not working as advertised and you\'ve attempted to resolve any issues with our support team, which couldn\'t get resolved, we will refund the whole amount given that you raised a refund request within the first 10 days of the purchase. Please email us at <a href="mailto:drupalsupport@xecurify.com">drupalsupport@xecurify.com</a> for any queries regarding the return policy or contact us <a href="https://www.miniorange.com/contact" target="_blank">here</a>.</p>
    </div>

    <button type="button" class="collapsible">Does miniOrange store any User data ?</button>
    <div class="content">
      <p>MiniOrange does not store or transfer any data which is coming from the OAuth / OIDC provider to the Drupal. All the data remains within your premises / server.</p>
    </div>

    </div>

  </div>

</div>
<!-- FAQ End-->

<!--Watch Premium Version Features -->

<div class="container mo-container" id="video">

<h3>WATCH PREMIUM VERSION FEATURES</h3><br><hr>

<div class="row">
<div class="col-md-4 " id="premium_video">
   <p>
    <h4>Attribute Mapping</h4>
    <a href="https://youtu.be/FnrtWxzbNjk" target="_blank"><img alt=" Drupal Oauth Client Attribute Mapping" class="center" height="295" src="'. $base_url . '/' . $module_path . '/includes/images/attribute_mapping.png" width="400" /></a>
   </p>
</div>
<div class="col-md-4">
  <p>
    <h4>Role Mapping</h4>
    <a href="https://youtu.be/1E_uk1RDoMw" target="_blank"><img alt=" Drupal OAuth Client Role Mapping" class="center" height="295" src="'. $base_url . '/' . $module_path . '/includes/images/role_mapping.png" width="400" /></a>
  </p>
</div>
</div>

</div>

<!--End of Watch Premium Version Features-->

<!--Supported Payment methods-->

<div class="container mo-container payment_method_main_divs" id="payment_method">
    <h3 style="text-align: center; margin:3%;">PAYMENT METHODS</h3><hr><br><br>
    <div class="row">
    <div class="col-md-3 payment_method_inner_divs">
        <div><img src="'. $base_url . '/' . $module_path . '/includes/images/card_payment.png" width="120" ><h4>Card Payment</h4></div><hr>
        <p>If the payment is made through Credit Card/International Debit Card, the license will be created automatically once the payment is completed.</p>
    </div>
    <div class="col-md-3 payment_method_inner_divs">
        <div><img src="'. $base_url . '/' . $module_path . '/includes/images/bank_transfer.png" width="150" ><h4>Bank Transfer</h4></div><hr>
        <p>If you want to use bank transfer for the payment then contact us at <a href="mailto:drupalsupport@xecurify.com">drupalsupport@xecurify.com</a> so that we can provide you the bank details.</p>
    </div>
    <div class="col-md-3 payment_method_inner_divs">
        <div><img src="'. $base_url . '/' . $module_path . '/includes/images/paypal.png" class="payment_img" width="120"><h4>PayPal</h4></div><hr>
          <p>Please contact us <a href="https://www.miniorange.com/contact" class="text-primary" target="_blank"><b>here</b></a> or drop an email at <a href="mailto:drupalsupport@xecurify.com"><b>drupalsupport@xecurify.com</b></a> for more information     </p>
    </div>
    </div>
</div>

<!-- End of supported payment methods-->

    </body>
    </html>'),
        );
        $form['markup_6'] = array(
            '#markup' => '<p>
            <br><b>*</b> There is an additional cost for the OAuth Providers if the number of OAuth Provider is more than 1.</p><br>
        '
        );

        return $form;
    }

    public function submitForm(array &$form, FormStateInterface $form_state) {

    }
}

